// go through each table and if it has a <td> with class 'align-dec'
// then we need to align the decimal points for those columns
$('table').each(function() {
    var hasAlignDec = [];

    if ($(this).find('td.align-dec').length) {
	// find all the columns with 'align-dec'
	safe_log("table #" + $(this).parent().attr('id') + " has class align-dec");
    }
    else {
	return;
    }

    // find the columns that have class 'align-dec'
    var $rows = $(this).find('tr');

    // find the max number of digits after decimal for each column that has
    // class 'align-dec'
    $rows.each(function() {
	$.each(this.cells, function(index){
	    var $this = $(this);
            if ($this.hasClass('align-dec')) {
		// how many numbers after decimal
		var number = $this.text();
		var dmatch = number.match(/.*\.([^\.]+)/);
		if (dmatch !== null) {
		    if (hasAlignDec[index] === undefined) {
			hasAlignDec[index] = dmatch[1].length;
		    }
		    else if (dmatch[1].length > hasAlignDec[index]) {
			hasAlignDec[index] = dmatch[1].length;
		    }
		}
		else {
		    if (hasAlignDec[index] === undefined) {
			hasAlignDec[index] = 0;
		    }
		}
	    }
	});
    });
    
    // go back through each row and pad digits after decimal
    $rows.each(function() {
	$.each(this.cells, function(index){
	    var $this = $(this);
	    if ($this.hasClass('align-dec')) {
		// how many numbers after decimal
		var number = $this.text();
		var dmatch = number.match(/.*\.([^\.]+)/);
		var new_number;
		if (dmatch !== null) {
		    if (dmatch[1].length < hasAlignDec[index]) {
			new_number = number + "<span class='align-dec-hide' style='color: transparent; visibility: hidden;'>" + add_zeros(hasAlignDec[index] - dmatch[1].length) + "</span>";
		    }
		}
		else {
		    new_number = number + "<span class='align-dec-hide' style='color: transparent; visibility: hidden;'>." + add_zeros(hasAlignDec[index]) + "</span>";
		}
		$this.html(new_number);
	    }
	});
    });

    function add_zeros(num) {
	var zeros = "";
	for (var i=0; i<num; i++) {
	    zeros += "0";
	}
	return zeros;
    }
});
